package ru.ulstu.extractor.markup.service;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import ru.ulstu.extractor.markup.model.Markup;
import ru.ulstu.extractor.markup.model.MarkupForm;
import ru.ulstu.extractor.markup.repository.MarkupRepository;
import ru.ulstu.extractor.ts.model.TimeSeries;
import ru.ulstu.extractor.ts.service.TimeSeriesService;

@Service
public class MarkupService {
    private final MarkupRepository markupRepository;
    private final TimeSeriesService timeSeriesService;

    public MarkupService(MarkupRepository markupRepository,
                         TimeSeriesService timeSeriesService) {
        this.markupRepository = markupRepository;
        this.timeSeriesService = timeSeriesService;
    }

    @Transactional
    public void saveMarkup(MarkupForm markupForm) {
        markupForm.getMarkupRows().forEach(markupRow -> {
            TimeSeries timeSeries = timeSeriesService.getById(markupRow.getTimeSeries().getId());
            markupRepository.save(new Markup(timeSeries, markupRow.getMarkup()));
        });
    }
}
